<?php

namespace Drupal\cforge_gdpr;

use Symfony\Component\HttpFoundation\RedirectResponse;
use Symfony\Component\HttpKernel\KernelEvents;
use Symfony\Component\HttpKernel\Event\GetResponseEvent;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;

/**
 * Check the user has consented and redirect them to the consent form.
 * @todo inject currentuser
 */
class EventSubscriber implements EventSubscriberInterface {

  const ACCEPT_FORM_URL = '/gdpr/accept';

  /**
   * @param GetResponseEvent $event
   */
  public function checkConsent(GetResponseEvent $event) {
    $account = \Drupal::currentUser();
    if ($account->isAuthenticated() and $event->getRequest()->getPathInfo() != SELF::ACCEPT_FORM_URL) {
      if (!cforge_gdpr_signed($account->id())) {
        $event->setResponse(new RedirectResponse(SELF::ACCEPT_FORM_URL));
      }
    }
  }

  /**
   * {@inheritdoc}
   */
  public static function getSubscribedEvents() : array {
    $events[KernelEvents::REQUEST][] = array('checkConsent');
    return $events;
  }

}

